require 'omniauth-oauth2'

module OmniAuth
  module Strategies
    class Fenix < OmniAuth::Strategies::OAuth2
      option :name, 'fenix'

      option :client_options, {
        :token_url     => 'https://fenix.tecnico.ulisboa.pt/oauth/access_token',
        :authorize_url => 'https://fenix.tecnico.ulisboa.pt/oauth/userdialog'
      }

      def request_phase
        super
      end

      uid { raw_info['username'] }

      info do
        {
          'name' => raw_info['name'],
          'username' => raw_info['username'],
          'email' => raw_info['email'],
          'roles' => raw_info['roles']
        }
      end

      def raw_info
        access_token.options[:parse] = :json
        url = "https://fenix.tecnico.ulisboa.pt/api/fenix/v1/person"
        params = { :params => { :access_token => access_token.token } }
        @raw_info ||= access_token.get(url, params).parsed
      end

      def build_access_token
        token_params = {
          :code => request.params['code'],
          :redirect_uri => callback_url.split('?').first,
          :client_id => client.id,
          :client_secret => client.secret,
          :grant_type => 'authorization_code'
        }

        client.get_token(token_params)
      end
    end
  end
end
